#!/usr/bin/python
# -*- coding: utf-8 -*-

#bumping balls in 3D
#Copyright (C) 2009  Janosch Maier <janosch_maier@online.de>
#For further information see <http://phylu.bplaced.de>

#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.


## Klasse zu Definition der Kugeln ##
class ball:
    def __init__(self, r, m, rx, ry, rz, vx, vy, vz, red, green, blue, divisor): # class ball() definieren
        self.divisor = divisor
        self.r = r # Variablen übergeben
        self.m = m
        self.rx = rx
        self.ry = ry
        self.rz = rz
        self.vx = vx / self.divisor # Um dem Benutzer nicht mit zu kleinen Zahlen hantieren lassen zu müssen
        self.vy = vy / self.divisor
        self.vz = vz / self.divisor
        self.red = red
        self.green = green
        self.blue = blue

    def setPosition(self, rx, ry, rz): # Funktionen, um später Variablen zu ändern; werden von der calculate() aufgerufen
        self.rx = rx
        self.ry = ry
        self.rz = rz

    def setSpeed(self, vx, vy, vz):
        self.vx = vx
        self.vy = vy
        self.vz = vz
        
    def getVars(self): # alle Variablen als Liste übergeben
        return [self.r, self.m, self.rx, self.ry, self.rz, self.vx * self.divisor, self.vy * self.divisor, self.vz * self.divisor, self.red, self.green, self.blue]
        
    def setVars(self, var): # Alle Variablen als Liste einlesen
        self.r = var[0]
        self.m = var[1]
        self.rx = var[2]
        self.ry = var[3]
        self.rz = var[4]
        self.vx = var[5] / self.divisor # Um dem Benutzer nicht mit zu kleinen Zahlen hantieren lassen zu müssen
        self.vy = var[6] / self.divisor
        self.vz = var[7] / self.divisor
        self.red = var[8]
        self.green = var[9]
        self.blue = var[10]
